/*
 * unlink.c
 *
 * Copyright (C) 1993 Alain Knaff
 */
#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/stat.h>
#include <sys/param.h>
#include <string.h>
#include <syscall.h>
#include "zlibc.h"

#ifdef NEED_PROTOTYPES
int unlink(__const char *file_name)
#else
int unlink(file_name)
char *file_name;
#endif
{
  int st;
  struct stat buf;
  char newname[MAXPATHLEN + MAXEXTLEN + 1];


  st = syscall(SYS_unlink,file_name);

  if ( st >= 0 || errno != ENOENT )
    return st;

  zlib_initialise();
  if ( zlib_mode & CM_DISAB )
    return st;
  
  if ( zlib_mode & CM_VERBOSE )
    fprintf(stderr,"Unlinking %s\n",file_name);
  
  strncpy(newname,file_name,1024);
  strcat(newname,zlib_ext);
  
  errno = 0;
  if ( zlib_mode & CM_UNLINK)
    return syscall(SYS_unlink,newname);
  
  st = syscall(SYS_lstat,newname, &buf);
  if ( st < 0 )
    return st;
  
  /* the file exists with z extension, ignore error */
  return 0;
}
